diff --git a/gnu/services/vpn.scm b/gnu/services/vpn.scm
index b24e9cffb3..e3f5ff0d05 100644
--- a/gnu/services/vpn.scm
+++ b/gnu/services/vpn.scm
@@ -62,6 +62,7 @@ (define-module (gnu services vpn)
             wireguard-peer-allowed-ips
             wireguard-peer-public-key
             wireguard-peer-keep-alive
+            wireguard-peer-preshared-key
 
             wireguard-configuration
             wireguard-configuration?
@@ -701,6 +702,8 @@ (define-record-type* <wireguard-peer>
   (endpoint          wireguard-peer-endpoint
                      (default #f))     ;string
   (public-key        wireguard-peer-public-key)   ;string
+  (preshared-key     wireguard-peer-preshared-key
+                     (default #f))   ;string
   (allowed-ips       wireguard-peer-allowed-ips) ;list of strings
   (keep-alive        wireguard-peer-keep-alive
                      (default #f)))    ;integer
@@ -727,16 +730,20 @@ (define (wireguard-configuration-file config)
   (define (peer->config peer)
     (let ((name (wireguard-peer-name peer))
           (public-key (wireguard-peer-public-key peer))
+          (preshared-key (wireguard-peer-preshared-key peer))
           (endpoint (wireguard-peer-endpoint peer))
           (allowed-ips (wireguard-peer-allowed-ips peer))
           (keep-alive (wireguard-peer-keep-alive peer)))
       (format #f "[Peer] #~a
 PublicKey = ~a
 AllowedIPs = ~a
-~a~a"
+~a~a~a"
               name
               public-key
               (string-join allowed-ips ",")
+              (if preshared-key
+                  (format #f "PresharedKey = ~a\n" preshared-key)
+                  "")
               (if endpoint
                   (format #f "Endpoint = ~a\n" endpoint)
                   "")
